function odesliProNavrhy(preklep) {
	console.log('AJAX: odesliProNavrhy()');

	var request = $.ajax({
		type: 'POST',
		url: 'pravopis.pl',
		data: { preklep: encodeURIComponent(preklep) }
	});
	
	request.done(function(responseText) {
		if (document.getElementById("cordivnavrhy")) {
			var navrhyString = responseText;
			var navrhyPole = navrhyString.match(/<option.*?>/gi);
			html = "<select id='cornavrhy' size='10' style='width:150px;'  onchange=\"nastavTextDleSelectu(this, this.form.cortext)\" ondblclick=\"provedKorekci(this.value)\">";
			if (navrhyPole){
				html += responseText;
			}
			html += "</select>";
			document.getElementById("cordivnavrhy").innerHTML = html;
		}
	});

	request.fail(function(xhr, textStatus) {
		alert('Request failed: ' + textStatus);
	});

	/*if (ajaxOn()) {      
		var metoda = "POST";
		var url = "pravopis.pl";
		var parametry = "preklep=" + encodeURIComponent(preklep);
		try {
			xmlhttp.open(metoda, url, true);
			xmlhttp.onreadystatechange = zakomponujNavrhy;
			xmlhttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded;");
			xmlhttp.send(parametry);
		}
		catch (e) {
			alert(""+TranslVar[419]+":\n" + e.toString());
		}
	}
	else { // ajaxOn vratil false
		alert(""+TranslVar[419]+".");
	}*/
}

/*function zakomponujNavrhy() {
	if (xmlhttp.readyState == 4) {
		if (xmlhttp.status == 200) {
			if (document.getElementById("cordivnavrhy")) {
				var navrhyString = xmlhttp.responseText;
				var navrhyPole = navrhyString.match(/<option.*?>/gi);
				html = "<select id='cornavrhy' size='10' style='width:150px;'  onchange=\"nastavTextDleSelectu(this, this.form.cortext)\" ondblclick=\"provedKorekci(this.value)\">";
				if (navrhyPole){
					html += xmlhttp.responseText;
				}
				html += "</select>";
				document.getElementById("cordivnavrhy").innerHTML = html;
			}
		}
	}
}*/

function pridejDoSlovniku(slovo) {

	var request = $.ajax({
		type: 'POST',
		url: 'pravopis.pl',
		data: { termin: encodeURIComponent(slovo) }
	});
	
	request.done(function(responseText) {
		corectorMessage("&bdquo;"+slovo+"&ldquo; "+TranslVar[421]+"");
		ignorujPreklep(slovo);
	});

	request.fail(function(xhr, textStatus) {
		corectorMessage(""+TranslVar[422]+"");
	});

	/*if (ajaxOn()) {      
		var metoda = "POST";
		var url = "pravopis.pl";
		var parametry = "termin=" + encodeURIComponent(slovo);
		try {
			xmlhttp.open(metoda, url, true);
			xmlhttp.onreadystatechange = function() { dokonciPridaniDoSlovniku(slovo); };
			xmlhttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded;");
			xmlhttp.send(parametry);
		}
		catch (e) {
			alert(""+TranslVar[420]+":\n" + e.toString());
		}
	}
	else { // ajaxOn vratil false
		alert(""+TranslVar[420]+"");
	}*/
}

/*function dokonciPridaniDoSlovniku(slovo) {
	if (xmlhttp.readyState == 4) {
		if (xmlhttp.status == 200) {
			corectorMessage("&bdquo;"+slovo+"&ldquo; "+TranslVar[421]+"");
			ignorujPreklep(slovo);
		}
		else {
			corectorMessage(""+TranslVar[422]+"");
		}
	}
}*/

var timeout = null; 

function corectorMessage(text) {
	var messageDiv = null;
	if (!document.getElementById("corMessage")) {
		messageDiv = document.createElement("div");
		messageDiv.setAttribute("id", "corMessage");
		document.body.appendChild(messageDiv);
		messageDiv.style.position = "absolute";
		messageDiv.style.padding = "5px";
		messageDiv.style.border = "1px dotted #ff0000";
		messageDiv.style.fontWeight = "bold";
		messageDiv.style.background = "#ffffff";
		messageDiv.style.textAlign = "left";
		messageDiv.style.zIndex = 50;
	}
	else {
		messageDiv = document.getElementById("corMessage");
	}
	messageDiv.style.top = document.body.scrollTop + 20;
	messageDiv.style.left = document.body.scrollLeft + 20;
	messageDiv.style.display = "block";
	messageDiv.innerHTML = text;
	if (timeout) {
		clearTimeout(timeout);
	}
	timeout = setTimeout("removeCorectorMsg()", 3000);
}

function removeCorectorMsg() {
	if (document.getElementById("corMessage")) {
		document.getElementById("corMessage").style.display = "none";
	}
	timeout = null;
}

function ignorujPreklep(slovo) {
	var tagyS = editor.document.getElementsByTagName("s");
	var nodeKeKorekci = pravopis.node;
	var rodicKontejneru = null;
	var opravaUzel = null;
	for (var i = 0; i < tagyS.length; i++) {
		if (tagyS[i].firstChild.nodeValue == slovo) { // Toto zvyrazneni <s></s> obsahuje slovo, co chceme ignorovat.
			if (nodeKeKorekci == tagyS[i]) { // Pokud je totozne s opravovanym uzlem, pripravime dalsi mozny uzel pro volani korekce().
				if (i < tagyS.length - 1) {
					//alert("nastavuji ke korekci na " + (i+1));
					nodeKeKorekci = tagyS[i+1];
				}
				else {
					nodeKeKorekci = null;
				}
			}
			// Nahradime zvyrazneni tagyS[i] za textnode 'slovo':
			rodicKontejneru = tagyS[i].parentNode; // pomocny uzel-rodic
			opravaUzel = document.createTextNode(slovo); // z retezce vytvorime textovy uzel
			if (rodicKontejneru != null) {
				rodicKontejneru.replaceChild(opravaUzel, tagyS[i]); // nahradime <s></s> slovem -> zmizi zvyrazneni
			}//nám to frčí jenom 3, protože sme koncoví uživatelé, ale standartně to má frčet 8
			i -= 1; // Protoze nahrazeny uzel zmizi i z pole tagyS, je nutne pocitadlo snizit o 1, abychom nepreskocili nasledujici uzel <s>.
		}
	}
	korekce(nodeKeKorekci); // zavolame korekci dalsiho mozneho uzlu
	if (pravopis.node) editor.scrollTo(0, getTop(pravopis.node) - (ob.offsetHeight / 2)); // Narolujeme preklep do pohledu.
}

function spellChecker() {

	if (!pravopis.on) {
		var request = $.ajax({
			type: 'POST',
			url: 'pravopis.pl',
			data: { spell: 1, pole: encodeURIComponent(document.getElementById(idArea).value) }
		});

		otevriDialog("dlgSpell",""+TranslVar[299]+"");
		
		request.done(function(responseText) {
			if (responseText != "") {
				//close("dlgSpell");
				$("#dlgSpell").dialog('close');
				switchInactive(""+TranslVar[299]+"");
				if (!isHighlight) { // Pokud nejsme v rezimu zvyraznovani, rezim zapneme a zapamatujeme si to:
					switchSyntax();
					pravopis.txtBefore = true;
				}
				else { // Pokud jsme v rezimi zvyraznovani, zapamtujeme si to:
					pravopis.txtBefore = false;
				}
				if (browser.ns) {
					editor.document.designMode = 'off'; // vypnu editovatelnost iframe
				}
				else if (browser.ie) {
					editor.document.body.contentEditable = 'false';
				}
				editor.document.body.style.background = "#DDDDDD"; // pozadi editoru necht zsedne
				var kod = editor.document.body.innerHTML.replace(/<\/?s ?.*?>/gi,""); // pro jistotu odstranime vsechny <s>
				// odtud nove
				var slovo = new RegExp();
				var polePreklepu = responseText.split(' '); // preklepy v retezci ze serveru rozsekneme do pole

				for (var i = 0; i < polePreklepu.length - 1; i++) { // -1 proto, ze preklepy ze serveru konci mezerou
					slovo.compile("([^\\wáčďéěíóřšťúůýž])(" + polePreklepu[i] + ")(?![\\wáčďéěíóřšťúůýž])","gi");
					kod = kod.replace(slovo, "$1<s>$2</s>"); // oznaceni preklepu do <s></s>
				}

				kod = kod.replace(/<s>/gi, "<s onclick='window.top.window.korekce(this)'>"); // pridame udalost pro 'vyvolani bubliny'
				editor.document.body.innerHTML = kod;
				// potud nove
				pravopis.on = true;
				korekce(dejPrvniS());
				if (pravopis.node) editor.scrollTo(0, getTop(pravopis.node) - (ob.offsetHeight / 2)); // Narolujeme preklep do pohledu.
			} else {
				//close("dlgSpell");
				$("#dlgSpell").dialog('close');
				alert(""+TranslVar[435]+"")
			}
		});

		request.fail(function(xhr, textStatus) {
			alert('Request failed: ' + textStatus);
		});
	}

	// Funkce navaze pomoci AJAXu spojeni se serverem a odesle obsah TEXTAREA ke kontrole.
	// Zatim je povolena pouze ve Firefoxu a IE.
	/*if (browser.ns || browser.ie) {
		if (!pravopis.on) { // V pripade, ze jiz kontrola probiha, nenechame ji zavolat znovu...
			if (ajaxOn()) {      
				var metoda = "POST";
				var url = "pravopis.pl";
				setCode();
				// Nastaveni POST parametru -> 'spell' na 1 a 'pole' na obsah textarea.
				var parametry = "spell=1&pole=" + encodeURIComponent(document.getElementById(idArea).value);
				try {
					xmlhttp.open(metoda, url, true);
					xmlhttp.onreadystatechange = spellCheckerOn;
					xmlhttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded;");
					xmlhttp.send(parametry);
					otevriDialog("dlgSpell",""+TranslVar[299]+"");
				}
				catch (e) {
					alert(""+TranslVar[433]+":\n" + e.toString());
				}
			}
			else { // ajaxOn vratil false
				alert(""+TranslVar[433]+".");
			}
		}
	}
	else {
		alert(""+TranslVar[434]+".");
	}*/
}

/*function spellCheckerOn() {

	// Funkce na zaklade preklepu ze serveru bud zahaji kontrolu pravopisu (oznaci preklepy pomoci <s></s>) nebo
	// zobrazi alert, ze nebyl nalezen zadny preklep.
	if (xmlhttp.readyState == 4) {
		if (xmlhttp.status == 200) {
			if (xmlhttp.responseText != "") {
				//close("dlgSpell");
				$("#dlgSpell").dialog('close');
				switchInactive(""+TranslVar[299]+"");
				if (!isHighlight) { // Pokud nejsme v rezimu zvyraznovani, rezim zapneme a zapamatujeme si to:
					switchSyntax();
					pravopis.txtBefore = true;
				}
				else { // Pokud jsme v rezimi zvyraznovani, zapamtujeme si to:
					pravopis.txtBefore = false;
				}
				if (browser.ns) {
					editor.document.designMode = 'off'; // vypnu editovatelnost iframe
				}
				else if (browser.ie) {
					editor.document.body.contentEditable = 'false';
				}
				editor.document.body.style.background = "#DDDDDD"; // pozadi editoru necht zsedne
				var kod = editor.document.body.innerHTML.replace(/<\/?s ?.*?>/gi,""); // pro jistotu odstranime vsechny <s>
				// odtud nove
				var slovo = new RegExp();
				var polePreklepu = xmlhttp.responseText.split(' '); // preklepy v retezci ze serveru rozsekneme do pole

				for (var i = 0; i < polePreklepu.length - 1; i++) { // -1 proto, ze preklepy ze serveru konci mezerou
					slovo.compile("([^\\wáčďéěíóřšťúůýž])(" + polePreklepu[i] + ")(?![\\wáčďéěíóřšťúůýž])","gi");
					kod = kod.replace(slovo, "$1<s>$2</s>"); // oznaceni preklepu do <s></s>
				}

				kod = kod.replace(/<s>/gi, "<s onclick='window.top.window.korekce(this)'>"); // pridame udalost pro 'vyvolani bubliny'
				editor.document.body.innerHTML = kod;
				// potud nove
				pravopis.on = true;
				korekce(dejPrvniS());
				if (pravopis.node) editor.scrollTo(0, getTop(pravopis.node) - (ob.offsetHeight / 2)); // Narolujeme preklep do pohledu.
			} else {
				//close("dlgSpell");
				$("#dlgSpell").dialog('close');
				alert(""+TranslVar[435]+"")
			}
		}
	}
}*/

// pozn. Tato fce se nikde nevola?
function spellCheckerOff() {
	// Fce ukonci rezim kontroly pravopisu - zavre bubliny, nastavi pozadi editoru na bile, zapne editovatelnost
	// iframe, odstrani handlery udalosti 'onscroll' a v pripade, ze pred kontrolou bylo jako editor <textarea>,
	// prepneme rezim zvyraznovani.
	if (pravopis.on) {
		switchInactive(""+TranslVar[299]+"");
		editor.document.body.style.background = "#FFFFFF";
		if (browser.ns) {
			editor.document.designMode = 'on';
		}
		else if (browser.ie) {
			editor.document.body.contentEditable = 'true';
		}
		editor.document.body.innerHTML = editor.document.body.innerHTML.replace(/<\/?s ?.*?>/gi,"");
		pravopis.on = false;
		if (pravopis.txtBefore) {
			switchSyntax();
		}
	}
}

function korekce(kontejner) {
	if (kontejner != null) {
		if (pravopis.node != null) pravopis.node.style.backgroundColor = "yellow";
		pravopis.node = kontejner; // nastaveni globalni promenne
		//createDialog("dlgCorector");
		var preklep = (pravopis.node != null)? pravopis.node.firstChild.nodeValue : "-undefined-";
		otevriDialog("dlgCorector","Kontrola pravopisu",350);
		if (document.getElementById("cortext")) {
			document.getElementById("cortext").focus();
			document.getElementById("cortext").select();
		}
		kontejner.style.backgroundColor = "red";
	}
	else {
		close("dlgCorector");
	}
}

function rkorekce(kontejner) {
	if (kontejner != null) {
		if (pravopis.node != null) pravopis.node.style.backgroundColor = "yellow";
		pravopis.node = kontejner; // nastaveni globalni promenne
		//createDialog("dlgCorector");
		var preklep = (pravopis.node != null)? pravopis.node.firstChild.nodeValue : "-undefined-";
		if (document.getElementById("cortext")) {
			document.getElementById("cortext").focus();
			document.getElementById("cortext").select();
		}
		kontejner.style.backgroundColor = "red";
	}
	else {
	}
}

function predchoziKorekce() {
	var predchoziS = null;
	var tagyS = editor.document.getElementsByTagName("s");
	for (var i = 0; i < tagyS.length; i++) {
		if (tagyS[i] == pravopis.node) {
			if (i > 0) {
				predchoziS = tagyS[i-1];
			}
			else predchoziS = null;
		}
	}
	if (predchoziS) editor.scrollTo(0, getTop(predchoziS) - (ob.offsetHeight / 2));
	return predchoziS;
}

function dalsiKorekce() {
	var dalsiS = null;
	var tagyS = editor.document.getElementsByTagName("s");
	for (var i = 0; i < tagyS.length; i++) {
		if (tagyS[i] == pravopis.node) {
			if (i < tagyS.length-1) {
				dalsiS = tagyS[i+1];
			}
			else dalsiS = null;
		}
	}
	if (dalsiS) editor.scrollTo(0, getTop(dalsiS) - (ob.offsetHeight / 2));
	return dalsiS;
}

function kontrolaKorekce(oprava) {

	var request = $.ajax({
		type: 'POST',
		url: 'pravopis.pl',
		data: { spell: 1, pole: encodeURIComponent(oprava) }
	});
	
	request.done(function(responseText) {
		// Nahradime puvodni text opravou a pokud server odpovi, ze oprava neni preklep,
		// odstranime zvyrazneni pomoci <s></s>. V opacnem pripade jej nechame.
		// Cekame na odpoved serveru:
		if (responseText != "") { // slovo se vratilo jako preklep -> nahradime, ale zvyrazneni zachovame a posuneme se dal
			var kontejner = pravopis.node;
			kontejner.firstChild.nodeValue = oprava;
			korekce(dalsiKorekce());
		}
		else { // nic neprislo, oprava neni preklep -> zvyrazneni musi zmizet a posuneme se na dalsi preklep
			var kontejner = pravopis.node;
			var rodicKontejneru = kontejner.parentNode; // pomocny uzel-rodic
			var opravaUzel = document.createTextNode(oprava); // z retezce vytvorime textovy uzel
			var dalsi = dalsiKorekce();
			if (rodicKontejneru != null) {
				rodicKontejneru.replaceChild(opravaUzel, kontejner); // nahradime <s></s> opravou -> zmizi zvyrazneni
			}
			korekce(dalsi);
		}
	});

	request.fail(function(xhr, textStatus) {
		alert('Request failed: ' + textStatus);
	});

	// Fce navaze spojeni pomoci AJAXu se serverem a odesle ke kontrole pravopisu (spell=1)
	// zadanou opravu. Vyhodnoceni provede funkce 'provedKorekci()'.
	/*if (ajaxOn()) {      
		var metoda = "POST";
		var url = "pravopis.pl";
		var parametry = "spell=1&pole=" + encodeURIComponent(oprava);
		try {
			xmlhttp.open(metoda, url, true);
			xmlhttp.onreadystatechange = function() { provedKorekci(oprava) }
			xmlhttp.setRequestHeader("Content-Type","application/x-www-form-urlencoded;");
			xmlhttp.send(parametry);
		}
		catch (e) {
			alert(""+TranslVar[436]+":\n" + e.toString());
		}
	}*/
	return false;
}

/*function provedKorekci(oprava) {
	// Nahradime puvodni text opravou a pokud server odpovi, ze oprava neni preklep,
	// odstranime zvyrazneni pomoci <s></s>. V opacnem pripade jej nechame.
	// Cekame na odpoved serveru:
	if (xmlhttp.readyState == 4) {
		if (xmlhttp.status == 200) { 
			if (xmlhttp.responseText != "") { // slovo se vratilo jako preklep -> nahradime, ale zvyrazneni zachovame a posuneme se dal
				var kontejner = pravopis.node;
				kontejner.firstChild.nodeValue = oprava;
				korekce(dalsiKorekce());
			}
			else { // nic neprislo, oprava neni preklep -> zvyrazneni musi zmizet a posuneme se na dalsi preklep
				var kontejner = pravopis.node;
				var rodicKontejneru = kontejner.parentNode; // pomocny uzel-rodic
				var opravaUzel = document.createTextNode(oprava); // z retezce vytvorime textovy uzel
				var dalsi = dalsiKorekce();
				if (rodicKontejneru != null) {
					rodicKontejneru.replaceChild(opravaUzel, kontejner); // nahradime <s></s> opravou -> zmizi zvyrazneni
				}
				korekce(dalsi);
			}
		}
	}
}*/

function nastavTextDleSelectu(select, text) {
	if (select && text) {
		if (select.value != "") {
			text.value = select.value;
			text.focus();
			text.select();
		}
	}
}

function dejPrvniS() {
	return editor.document.getElementsByTagName("s")[0];
}
