$(function() {
	
	$( "#templates" ).click(function() {
		changeTemplateIconText();
		$( "#templatesList" ).toggle( "slide", "left", "fast" );		
	});
	
	// Na desktopu se oteviraji sablony pomoci double click
	if (isDesktop()) {	
		$( "#templatesList #xtable tbody tr" ).dblclick(function() {
			var template = $(this).children().attr("abbr");
			window.location.href = "index.pl?styl=" + template;
		});
	
	// Na mobilnim zarizeni se oteviraji pres tap
	} else {
		var templates = $( "#templatesList #xtable tbody tr" );
	
		for (var i=0; i < templates.length; i++){
			templates[i].addEventListener('touchend', function(e){
				var template = $(this).children().attr("abbr");
                		window.location.href = "index.pl?styl=" + template;
			}, false);

		}
	}
});

// Funkce pro prepinani ikony a textu tlacitka sablony
function changeTemplateIconText(){
	// Pokud je text tlacitka nastaven na Šablony
	if ($( "#templates" ).text() == TranslVar[283]) {
		// Nastav na hodnotu Zpět
		$( "#templates" ).text(TranslVar[0]);
		$( "#templates" ).removeClass("template-icon");	
		$( "#templates" ).addClass("back-arrow-icon");	
	} else {
		$( "#templates" ).text(TranslVar[283]);
		$( "#templates" ).removeClass("back-arrow-icon");
		$( "#templates" ).addClass("template-icon");
	} 
}
