//*************************************************************************************************
//              REAKCE NA TLACITKA SPRAVCE SOUBORU
//*************************************************************************************************

$(function() {
	//Blok udalosti, ktere se spousti pouze v pripade, ze je uzivatel autentizovan
	if (isUserAutheticated()){

		$( "#open_file, #files" ).click(function() {
			// Schovej sablony pokud jsou zobrazeny
			if ($( "#templatesList" ).is( ":visible" )){
				changeTemplateIconText();
				$( "#templatesList" ).toggle( "slide", "left", "fast" );
			}

        		// Nacti soubory jen v pripade, ze se spravce souboru spousti
                	if ($( "#fileManager" ).is(":not(:visible)")){
                        		readFiles("");
                	}

			initFileMenu("browse");

			// Skryti praveho rolovatka na strance, kdyz je zobrazen spravce souboru
			$( "body" ).css("overflow", "hidden");
			// Zobrazit spravce souboru a jeho kontextovou nabidku
                	$( "#sideMenuFiles" ).toggle( "slide", "left", "fast");
                	$( "#fileManager" ).toggle( "slide", "left", "fast", setWidthSideContent );
        	});

		// Kliknuti na Ulozit v hlavni nabidce
		$( "#save_file" ).click(function (){
			// Nacti soubory jen v pripade, ze soubor neni jeste ulozen neboli nacten v editoru
			if (!isFileOpen()) {
				// Schovej sablony pokud jsou zobrazeny
				if ($( "#templatesList" ).is( ":visible" )){
                                	changeTemplateIconText();
                                	$( "#templatesList" ).toggle( "slide", "left", "fast" );
                        	}

                        	readFiles("");
				initFileMenu("save");
                		//Zobrazit spravce souboru a jeho kontextovou nabidku
                		$( "#sideMenuFiles" ).toggle( "slide", "left", "fast");
                		$( "#fileManager" ).toggle( "slide", "left", "fast", setWidthSideContent);
				$( "#file_name" ).focus();
			} else {
				// Pokud soubor je jiz ulozen a tedy nacten v editoru, pak ho jen uloz
				var fileName = $('#openFile').val();
				var path = $('#openFileDir').val();
				// Priprava cesty k ulozeni souboru
				$("#fullPathSave").val(path + fileName);
                                // Ziskani instance editoru a ulozeni jeho obsahu do textarea
                                var editor = ace.edit("codeEdit");
                                var content = editor.getSession().getValue();
                                $("#pole").val(content);
                                // Serializace textarea a plne cesty k ukladanemu souboru
                                var serializedFormFields = $("#pole, #fullPathSave").serialize();

				$.post("index.pl", serializedFormFields, function(data){
					// Commit souboru v pripade, ze ma uzivatel zapnute verzovani
					if(isVersion)
						commitSVN(file_nm, dir_nm);

					$("#fullPathSave").val("");
					// Uzavreni hlavni nabidky
					$( "#sideMenuMain" ).toggle( "slide", "left", "fast" );
					// Zobrazeni zpravy o uspesnem ulozeni a jeji nasledne skryti
					// $('#message').text(TranslVar[470]);
					// $('#message').removeClass("hidden");
					// setTimeout(function () { $('#message').addClass("hidden"); }, 1000);
					$('#flashMessages').flashMessage({
						text: TranslVar[470],
						className: 'success'
					});

					// Spusteni save eventu
					$(document).trigger('fileSaved');
				});
			}
		});

		// Ulozeni souboru jako, otevre nabidku pro ulozeni souboru, jakoby jeste nebyl nikdy ulozen
		// Polozka se zobrazi jen pokud je otevreny soubor, jinak neni polozka zobrazena
		if(isFileOpen()) {
			$("#save_file_as").click(function (){
				readFiles("");
                                initFileMenu("save");
                                //Zobrazit spravce souboru a jeho kontextovou nabidku
                                $( "#sideMenuFiles" ).toggle( "slide", "left", "fast");
                                $( "#fileManager" ).toggle( "slide", "left", "fast", setWidthSideContent);
                                $( "#file_name" ).focus();
			});
		} else {
			$("#save_file_as").hide();
		}

		// Inicialni ulozeni souboru, kliknuti na Ulozit v nabidce Spravce souboru
		$( "#save" ).click(function (){
			var fileName = $("#file_name").val();
			var path = getPath();
			if (duplicita_specialni_znak(fileName)) {
				$("#fullPathSave").val(path + fileName);
				// Ziskani instance editoru a ulozeni jeho obsahu do textarea
				var editor = ace.edit("codeEdit");
				var content = editor.getSession().getValue();
				$("#pole").val(content);
				// Serializace textarea a plne cesty k ukladanemu souboru
				var serializedFormFields = $("#pole, #fullPathSave").serialize();
				// Odeslani serializovanych dat na skript, ktery ulozi soubor na disk
				$.post("index.pl", serializedFormFields, function(data){
					// Vkladani nove vytvareneho souboru do SVN
                                        if(isVersion)
                                                vlozSouborSVN(file_nm,dir_nm);

					$("#fullPathSave").val("");
					// Zobrazeni zpravy o uspesnem ulozeni a jeji nasledne skryti
					$('#flashMessages').flashMessage({
						text: TranslVar[470],
						className: 'success'
					});
					// Presmerovani na prave ulozeny soubor
					window.location.href = "index.pl?soubor=" + path + fileName;
				});
			}
		});

        	$( "#closeFiles" ).click(function() {
                	$( "#fileManager" ).toggle( "slide", "left", "fast" );
                	$( "#sideMenuFiles" ).toggle( "slide", "left", "fast" );
			$( "body" ).css( "overflow", "");
        	});

        	$( "#file_new_list" ).click(function() {
                	// Ziskat jmeno souboru s cestou a pote otevrit v nove zalozce
                	openNewList();
        	});

        	$( "#rename" ).click(function() {
                	ren_this();
        	});

		$( "#delete" ).click(function() {
                	to_trash();
        	});

		$( "#create_dir" ).click(function() {
                	mkdir_this();
        	});

		$( "#move" ).click(function() {
			var selectedFile = getFileActual();

			if (!$( "#paste" ).is(":visible") && selectedFile) {
               			$( "#paste" ).slideToggle("fast");
			}

			if (selectedFile) {
                		filecopypaste("");
			}
        	});

		$( "#copy" ).click(function() {
			var selectedFile = getFileActual();

			if (!$( "#paste" ).is(":visible") && selectedFile) {
               			$( "#paste" ).slideToggle("fast");
			}

			if (selectedFile) {
                		filecopypaste("1");
			}
        	});

		$( "#paste" ).click(function() {
			filepaste();
		});

		$( "#change_encoding" ).click(function() {
			$( "#overlay" ).show();
			$( "#menu_encoding" ).show();
		});

		$( "#upload" ).click(function() {
                        prepare_file_upload();
                });

		$("#upload_file input[name=filename]").change(function() {
			upload_file();
		});

		$( "#download" ).click(function() {
			down_this();
		});

		// Reakce na tlacitka menu pro zmenu kodovani
		$( "#close_encoding" ).click(function() {
                        $( "#overlay" ).hide();
                        $( "#menu_encoding" ).hide();
                });

		$( "#submit_encoding" ).click(function() {
               		change_encoding()
               	});
		// Zobrazeni polozky pro stahnuti obsahu editoru
                $("#download_content").hide();

		// Reakce na uzavreni lightboxu
		$( "a.lb-close, div.lightboxOverlay, div.lightbox" ).click(function() {
			var imgName = $("#image_preview").attr("data-lightbox");
			deleteImage(imgName);
		});

		$(document).keyup(function(event) {
			if(event.which == 27 && $( "div.lightbox" ).is(":visible")){
				var imgName = $("#image_preview").attr("data-lightbox");
                        	deleteImage(imgName);
			}
		});
	} else {
		// Skryti polozek hlavniho menu tykajici se Spravce souboru, ktere neprihlaseny uzivatel nema videt
		$("#open_file, #save_file, #save_file_as, #files").hide();

		// Udalost pro stazeni obsahu editoru jako soubor
		$("#download_content").click(function() {
			var obsah = editor.getValue();
			$('#pole').val(obsah);

			$('#save_content_file').click();
		});
	}
})


//*************************************************************************************************
//		FUNKCE SPRAVCE SOUBORU
//*************************************************************************************************

function isFileOpen() {
	var url = window.location.href.toString();
	if (url.indexOf("?soubor=") != -1) {
		return true;
	} else {
		return false;
	}
}

function initFileMenu(action) {
	// Skryt vsechny polozky menu
	$(".menuItemFiles").hide();
	// Skryti textoveho pole pro nazev ukladaneho souboru
	$("#file_name_box").hide();
	switch(action){
		// Nastaveni menu spravce souboru pro beznou praci
		case 'browse':
                	$('#closeFiles').show();
			$('#create_dir').show();
			$('#upload').show();
			break;
		// Nastaveni menu spravce souboru pro ukladani
		case 'save':
			$('#closeFiles').show();
			$('#save').show();
			$('#file_name_box').show();
			break;

		case 'copy/move':
			$('#closeFiles').show();
                        $('#create_dir').show();
			$('#paste').show();
			$('#share').show();
			$('#upload').show();
			break;
		// Pokud je akce neznama ukonci funkci
		default:
			return false;
        }

	$('#action').val(action);
}

//Pomocna funkce pro vraceni cesty adresaru
function getPath(){
	return $("#filepath>td").text();
}

//Vraci vybranou polozku
function getFileActual(){
	var act_file = $("#fileManager #xtable .file_s").find("td:eq(0)").text();
	if (act_file != null){
		return act_file;
	};
}

function getFolderActual(){
	var act_fold = $("#fileManager #xtable .folder_s").find("td:eq(0)").text();
	if (act_fold != null){
		return act_fold;
	}
}

//funkce nastavi tlacitka pro rychle vyjiti se zanoreni podobne jak to ma resene GNOME
function setPaths(){
	var pom = $("#filepath>td").html();
	if ((pom!=null) && (pom.length > 1)){
		pom = pom.substr(0, (pom.length-1));
		pom = pom.replace(new RegExp("/", "g") ,  "\"><input type=\"button\" value=\"");
		pom = "<input type=\"button\" value=\""+pom+"\">";
	} else {pom="";}
	pom = "<input type=\"button\" value=\".\">"+pom;
	$("#fileclick").html(pom);
}

//vraci cestu k vybranemu souboru
function getFileN(){
	var name= $("#fileManager #xtable>tbody").find("tr.file_s").find("td:eq(0)").text();
	if (name !=null){
		return ""+getPath()+name;
	}
	return null;
}

function quitDir(){
	readFiles("..");
}

//funkce pro stahovani souborui
function down_this(){
	var path = getPath();
	var file_name = getFileActual();
	// Generovani nahodneho id pro iframe stahovaneho souboru
	var file = 'f' + Math.floor(Math.random() * 99999);

	// Nastaveni atributu formulare
	$("#download_file").attr("action", "sprava_souboru.pl");
	$("#download_file").attr("method", "post");
	$("#download_file").attr("target", file);

	$("#download_path").val(path);
	$("#download_name").val(file_name);

	$("#fileManager").append("<iframe style=\"display:none\" id=\""+file+"\" name=\""+file+"\"></iframe>");

	$("#download_file").submit();
}

function ren_this(){
	var adres = getPath();
	if (getFileActual()){
		var new_name =  prompt (TranslVar[466]+":",getFileActual());
		var old_name = getFileActual();
	} else if(getFolderActual()){
		var new_name = prompt (TranslVar[466]+":", getFolderActual());
		var old_name = getFolderActual();
	} else {
		var new_name="";
		var old_name="";
	}

	if(new_name && duplicita_specialni_znak(new_name)){
		if(!isVersion){
			$.post("sprava_souboru.pl", {rename: "rename", path: adres, filename: old_name, new_filename: new_name}, function(data){
				if(data == "1"){
					//readFiles(adres);
					renameFileToColaborators(adres, old_name, new_name);
				} else{
					alert("Nepodařilo se přejmenovat.");
				}
			});
		}else{
			prejmenujSouborSVN(adres, old_name, new_name);
		}
	}
}

function mkdir_this(){
	var adres = getPath();
	var new_name = prompt (TranslVar[467]+":", "");
	if (duplicita_specialni_znak(new_name)){
		$.post("sprava_souboru.pl", {mkdir:"mkdir", path: adres, filename: new_name}, function(data){
			if (data == "1"){
				if(!isVersion){
					readFiles(adres);
				}else{
					vlozSouborSVN(new_name, adres);
					readFiles(adres);
				}
			} else{
				alert("Složku se nepodařilo vytvořit. Složka s tímto názvem již existuje.");
			}

		});
	}
}

function to_trash(){
	var adres = getPath();

	if (getFileActual()){
		var old_name = getFileActual();
		var answer = confirm ("Opravdu chcete smazat soubor '"+old_name+"'?");
		if (answer){
			// Zjisteni typu mazaneho souboru
                        var fileType = $("#xtable td[abbr='"+old_name+"']").attr("ftype");
                        // Pokud je soubor symlink, tak dej vedet vlastnikovi, ze s nim nechceme mazany soubor sdilet
                        if (fileType == "l") {
				var shareFileName = "." + old_name + ".share";
                                $.post("sprava_sdileni.pl", {removeMyselfFromOwnerList : "removeMyselfFromOwnerList", path: adres, filename : shareFileName} ,function(data) {
					// po tom co dame vedet vlastnikovi smazeme soubor
					$.post("sprava_souboru.pl",{remove: "remove", path:adres, filename: old_name}, function(data){
                                        	if(data == "1"){
                                                	if(!isVersion){
                                                         	// readFiles(adres);
                                                        	deleteFileToColaborators(adres, old_name);
                                                	}else{
                                                        	odstranSouborSVN(old_name,adres);
                                                	}
                                        	}else{
                                                	alert("Nepodařilo se smazat soubor.");
                                        	}

                                	});
                                });
                        } else {
				// bezne smazani souboru, ktery neni link
				$.post("sprava_souboru.pl",{remove: "remove", path:adres, filename: old_name}, function(data){
                                	if(data == "1"){
                                        	if(!isVersion){
                                               		 // readFiles(adres);
                                                	deleteFileToColaborators(adres, old_name);
                                        	}else{
                                                	odstranSouborSVN(old_name,adres);
                                        	}
                                	}else{
                                        	alert("Nepodařilo se smazat soubor.");
                                	}

                        	});
			}
		}
	}else if(getFolderActual()){
		var old_name= getFolderActual();
		var answer = confirm("Opravdu chcete smazat složku '"+old_name+"'?");
		if (answer){
			if(!isVersion){
				$.post("sprava_souboru.pl",{rmdir:"rmdir",path:adres, filename: old_name}, function(data){
					if(data=="1"){
						readFiles(adres);
					}else{
						alert("Nelze smazat neprázdnou složku.");
					}
				});
			}else{
				odstranSouborSVN(old_name,adres);
			}
		}
	}
}

//zmena kodovani souboru
function change_encoding(){
	var adres = getPath();
	var file_name = getFileActual();
	var fcoding = $( "#select_encoding" ).val();

	$.post("sprava_souboru.pl", {path: adres, filename: file_name, recode:fcoding}, function(data){
		$( "#overlay" ).hide();
		$( "#menu_encoding" ).hide();
		readFiles(adres);
	});
}

//kopirovani nebo presunovani souboru
function filecopypaste(co){
	var name = getFileActual();
	var path = getPath();
	$("#filecopymove").val(co);
	if ((name != undefined) && (path != undefined)){
		$("#filecopyname").val(name);
		$("#filecopypath").val(path);
	}
	$("#action").val("copy/move");
}

function filepaste(){
	var name = $("#filecopyname").val();
	var path = $("#filecopypath").val();
	var path2 = getPath();
	var what = $("#filecopymove").val();

	// kopiruje pouze v pripade, ze v cilovem adresari neexistuje symlink se stejnym jmenem
	// presouva vzdy
	if (!isExistSymlink(name, what)) {
		name = name.toString();
        	// Regularni vyraz pro povolene znaky
        	var regEx = new RegExp("^[a-zA-Z0-9\._-]+$");
        	var duplicity = false;

        	$('#fileManager #xtable td.name').each(function(){
                	if($(this).text() == name){
                        	duplicity = true;
                	}
        	});

        	if (duplicity) {
			$( "#overlay" ).show();
                	var dialog = $("<p id='copyMoveDia'>" + TranslVar[492] + "</p>").dialog({
                		width : "570px",
                		heigh : "200px",
				open : function(){$("#copyMoveDia").parent().css("z-index", 150);},
				close : function(){
						$("#copyMoveDia").parent().remove();
						$("#paste").slideUp("fast");
						$( "#overlay" ).hide();
				},
                		buttons: {
                        		"rewrite" : {
                                		text : TranslVar[503],
                                		click : function() {
							ajaxMoveOrCopyFile(name, path, path2, what);
							dialog.dialog("close");
							$( "#overlay" ).hide();
						}
                        		},

                        		"cancel" :  {
                                		text : TranslVar[504],
                                		click : function() {
							$("#paste").slideUp("fast");
         						$("#action").val("browse");
							dialog.dialog("close");
							$( "#overlay" ).hide();
						}
                        		},

                        		"saveCopy" : {
                                		text : TranslVar[505],
                                		click : function() {
                                        		dialog.dialog('close');
							var newName =  prompt (TranslVar[466]+":",name);
							if (newName != name && newName != null) {
								if (regEx.test(newName)) {
									$.post( "sprava_souboru.pl" , {filename: name, new_filename: newName, path: path, path2: path2, saveCopy: "saveCopy"}, function(data){
                                 						$("#filecopymove").val("").hide();
                                 						$("#filecopypath").val("").hide();
                                 						$("#filepaste").hide();
                                 						readFiles(path2);
                          						});
								} else {
									$("#paste").slideUp("fast");
									alert(TranslVar[490]);
								}
							} else {
								$("#paste").slideUp("fast");
								if(newName != null)
									alert(TranslVar[506]);

							}
							$( "#overlay" ).hide();
                                		}
                        		}
                    		}
                	});

        	} else {
			ajaxMoveOrCopyFile(name, path, path2, what);
		}
	}
}

function ajaxMoveOrCopyFile(name, path, path2, what) {
	//kopirovat
         if (what == "1") {
        	 if (!isVersion) {
                	 $.post( "sprava_souboru.pl" , {filename: name, path: path, path2: path2, copy: "copy"}, function(data){
                        	 $("#filecopymove").val("").hide();
                                 $("#filecopypath").val("").hide();
                                 $("#filepaste").hide();
                                 readFiles(path2);
                          });
                 } else {
                        zkopirujSouborSVN(name , path, path2);
                 }
         //presouvat
         } else {
                 if (!isVersion) {
                        $.post( "sprava_souboru.pl" , {filename: name, path: path, path2: path2, move: "move"}, function(data){
                                $("#filecopymove").val("").hide();
                                $("#filecopypath").val("").hide();
                                $("#filepaste").hide();
                                //readFiles(path2);
                                // aktualizace linku pro sdileni dokumentu v pripade, ze je prousavany soubor zdrojovym
                                // pokud neni zdrojovy, pak se jen znovu nacte obsah Spravce souboru
                                renameFileToColaborators(path2, name, name);
                        });
                 } else {
                       presunSouborSVN(name , path, path2);
                 }
         }
         $("#paste").slideUp("fast");
         $("#action").val("browse");
}

//nacti ze skriptu do tabulky
function readFiles(pom){
        chcipniAllFile();
        var url = "jqueryFileTree.pl";
        $("#fileManager #xtable>tbody").html("<tr><td colspan=\"3\"><img src=\"file/loading.gif\" /></td></tr>");
        if (pom.replace(new RegExp("/(\s)/","g"), "") == ""){
                $.post(url, function(data){
                        $("#fileManager #xtable>tbody").html(data);
                }).done(function (){
                        chcipniFile();
                        initfile();
                });
        } else {
                pom = pom.replace(new RegExp("/$",""),"");
                $.post(url, {dir: pom}, function(data){
                        $("#fileManager #xtable>tbody").html(data);
                        setPaths();
                }).done(function () {
                        chcipniFile();
                        initfile();
                });
        }

        // Defaultne nastavuje menu Spravce souboru, podle toho co je ulozeno v akci
        initFileMenu($('#action').val());
}

// Otevre okno pro vyber nahravaneho souboru
function prepare_file_upload(){
	$("#upload_file input[name=filename]").click();
}

// Nahraje soubor na server
function upload_file(){
	var filename = $("#upload_file input[name=filename]").val();
	filename = filename.toString();

	// odstraneni retezce C:\fakepath\ ze jmena souboru na Chrome, IE a Safari
	if (filename.indexOf("C:\\fakepath\\") != -1)
		filename = filename.substring(filename.lastIndexOf("\\") + 1, filename.length);
	// Generovani nahodneho cisla pro nazev a id iframe, pro upload souboru
	var file = 'f' + Math.floor(Math.random() * 99999);
	// Nastaveni cesty k adresari, kam se ma soubor nahrat
	$("#upload_file input[name=path]").val(getPath());

	$("#upload_file").attr("action", "sprava_souboru.pl");
        $("#upload_file").attr("method", "post");
        $("#upload_file").attr("enctype", "multipart/form-data")
	$("#upload_file").attr("target", file);

	if (duplicita_specialni_znak(filename)) {
		if (confirm(TranslVar[495] + ": " + filename)) {
			$("#fileManager").append("<iframe style=\"display:none\" id=\""+file+"\" name=\""+file+"\" onload=\"file_uploaded(\'"+file+"\')\"></iframe>");
			// Zobrazeni informativni zpravy o nahravani
			$("#message").html("<img src=\"file/loading_grey.gif\" /> " + TranslVar[425]);
			$("#message").removeClass("hidden");
			$("#upload_file").submit();
		}
	}
}

// Funkce, ktera se zavola az je soubor nahran na serveru
function file_uploaded(file){
	var path = "";
	path = getPath();
	if(isVersion)
		vlozSouborSVN(filename, getPath());
	 // Skryti nahravaci zpravy
	 setTimeout(function () {
		$('#message').addClass("hidden");
	 	$("#message").html("");
		$("#"+file).remove();
         	$("#upload_file input[name=filename]").val("");
		readFiles(path);
	 }, 500);
}

function selectFolder(domObj){
	res_class();
        res_select();
        $(domObj).attr("class", $(domObj).attr("class")+"_s");
        //skryti menu pro presun a kopirovani souboru, pokud je spravce v rezimu bezne prace
	if ($('#action').val() == "browse" || $('#action').val() == "copy/move") {
		$("#rename").slideDown("fast");
		$("#delete").slideDown("fast");
        	$("#move").slideUp("fast");
        	$("#copy").slideUp("fast");
		$("#file_new_list").slideUp("fast");
		$("#change_encoding").slideUp("fast");
		$("#share").slideUp("fast");
                $("#download").slideUp("fast");
	}
}

function selectFile(domObj){
	res_class();
        res_select();
        $(domObj).attr("class", $(domObj).attr("class")+"_s");
        $("#nazevSouboru").val($(domObj).find("td:eq(0)").html());
        var trida = $(domObj).find("td:eq(0)").attr("class");
        var path = getFileN();
        // muze nabyvat hodnot f nebo l, f = obycejny soubor, l = symbolicky link
	// dale muze nabyvat hodnoty d, nicmene nikdy v teto funkci, d = adresar
	var fileType = $(domObj).children().attr('ftype');

	// Zobrazi menu pro otevirani souboru v nove karte, prejmenovani, presun, kopirovani a smazani souboru
	if ($('#action').val() == "browse" || $('#action').val() == "copy/move") {
        	// Nabidka pro vlastni soubory
		if ($(domObj).children().attr('abbr') != ".." && fileType == "f") {
			$("#file_new_list").slideDown("fast");
                        $("#rename").slideDown("fast");
			$("#move").slideDown("fast");
        		$("#copy").slideDown("fast");
			$("#delete").slideDown("fast");
			$("#change_encoding").slideDown("fast");
			$("#share").slideDown("fast");
			$("#download").slideDown("fast");
		}
		// Nabidka pro sdilene soubory
		if ($(domObj).children().attr('abbr') != ".." && fileType == "l") {
			$("#file_new_list").slideUp("fast");
                        $("#rename").slideUp("fast");
                        $("#move").slideUp("fast");
                        $("#copy").slideDown("fast");
                        $("#delete").slideDown("fast");
                        $("#change_encoding").slideUp("fast");
                        $("#share").slideDown("fast");
                        $("#download").slideUp("fast");
		}
	}

	// Vlozi nazev vybraneho souboru do pole pro nazev vytvarenoho souboru v rezimu prvotniho ukladani
	if($('#action').val() == "save") {
		var fileName = $(domObj).children(".name").text()
		if(fileName != "..")
			$('#file_name').val(fileName);
		else
			$('#file_name').val("");
	}
}

function openNewList(){
        //funkce ktera otevre v prohlizeci novou katu s vybranym souborem
	var fileName = getFileActual();
	if(fileName && fileName != "..") {
		var url = "index.pl?soubor=" + getPath() + fileName;
        	window.open(url,"_blank");
	}
}

function openFolder(domObj){
	var pom = getPath() + $(domObj).find("td:eq(0)").html();
        readFiles(pom);
}

function openFile(tableLine){
	var fileName = $(tableLine).children().attr('abbr');
	var extension = "";

	// Ziskani pripony souboru
	if (fileName.indexOf(".") != -1) {
		extension = fileName.split(".");
		extension = extension[1];
	}

	if (fileName == "..") {
		readFiles(getPath() + "..");
	} else if (extension == "jpg" || extension == "png" || extension == "jpeg" || extension == "image" || extension == "gif" || extension == "bmp") {
		openImage(getPath(), fileName);
	} else {
		window.location.href = "index.pl?soubor=" + getPath() + fileName;
	}
}

//fce rusi obarvena tr nad kterym byl kurzor
function res_class(){
	$("#fileManager #xtable>tbody").find("tr.folder_o").attr("class","folder");
        $("#fileManager #xtable>tbody").find("tr.file_o").attr("class","file");
}

//fce rusi vybrana tr
function res_select(){
        $("#fileManager #xtable>tbody").find("tr.folder_s").attr("class","folder");
        $("#fileManager #xtable>tbody").find("tr.file_s").attr("class","file");
}

//funkce, ktere nastavi trigery a pod po nacteni dialogu
function initfile(){
	//obarvovani radku
	//fce obarvi tr po najeti mysi a prida editacni tlacitka; bylo reseno tak, aby posledni sloupec nemenil pozadi, protoze by tlacitka pak nefungovala spravne
	//modifikator .find("td:eq(n)") nefunkcni v kombinaci s fci .live(), proto reseno takto
	$("#fileManager #xtable>tbody>tr").on("mouseover", function(){
		res_class();
		var pom = $(this).attr("class");
		if ((pom != "file_s") && (pom !=  "folder_s")){
			$(this).attr("class",$(this).attr("class")+"_o");
		}
		$(this).find("td:eq(3)").html();
	});

	setPaths();
	//vyber tr file - reseni, aby posledni sloupec nic nedelal

	$("#fileManager #xtable>tbody>tr").on("click", function(){
		switch($(this).attr('class')){
			case 'file_o': selectFile(this); break;
			case 'folder_o': selectFolder(this); break;
			case 'folder_s': openFolder(this); break;
			case 'file_s': openFile(this); break;
		}
	});

	setPaths();
}

//funkce pro zjisteni specialnich zanku v nazvu souboru pred ulozenim a kontroli jestli souboru jiz neexistuje
function duplicita_specialni_znak(souborNm){
	souborNm = souborNm.toString();
	// Regularni vyraz pro povolene znaky
	var regEx = new RegExp("^[a-zA-Z0-9\._-]+$");

	if(souborNm.indexOf('..') != -1 || souborNm.indexOf('/') != -1 || !regEx.test(souborNm)){
		alert(TranslVar[490]);
		return false;
	}else{
		var duplFol = false;
		var duplFil = false;

		$('#fileManager #xtable td.name').each(function(){
			if($(this).text() == souborNm){
				var parentNodeClass = $(this).parent().attr('class').toString();
				if(parentNodeClass.indexOf('folder') != -1){
					duplFol = true;
				}else if(parentNodeClass.indexOf('file') != -1){
					duplFil = true;
				}
			}
		});

		if(duplFol){
			alert(TranslVar[491]);
			return false;
		}else if(duplFil){
			return confirm(TranslVar[492]);
		}else{
			return true;
		}
	}
}

// funkce pro zjisteni, zda v cilovem adresari existuje symbolicky link se stejnym jmenem v pripade, ze chceme kopirovat
// parametr operation muze nabyvat hodnot 1, 0
// 1 = kopirovani
// prazdna hodnota = presun
function isExistSymlink(fileName, operation){
	var isExist = false;
	// chci kopirovat
	if (operation == "1") {
		$('#fileManager #xtable td.name').each(function() {
                        // v cilovem adresari je soubor se stejnym jmenem a zaroven je to symbolicky link a zaroven chceme kopirovat
			if ($(this).text() == fileName && $(this).attr('ftype') == "l") {
       				isExist = true;
                        }
		});
	}

	if (isExist) {
		alert(TranslVar[500]);
		return true;
	} else {
		return false;
	}
}

// Funkce, ktera nakopiruje zobrazovany obrazek do adresare imgTemp/ a zobraziho pres lightbox
function openImage(imgPath, imgName){
	var uniqueName = Math.floor(Math.random() * 99999);
	$.post( "sprava_souboru.pl" , {filename: imgName, path: imgPath, uniquename: uniqueName, prepareImg: "prepareImg"}, function(data){
		$("#image_preview").attr("href", "http://tex.mendelu.cz/tmp/" + uniqueName);
        	$("#image_preview").attr("data-lightbox", uniqueName);
        	$("#image_preview").attr("data-title", imgName);
        	$("#image_preview").html("text", imgName);
        	$("#image_preview").click();
	});
}

// Funkce, ktera smaze docasne uchovavany soubor v adresari tmp/
function deleteImage(imgName){
	$.post( "sprava_souboru.pl" , {filename: imgName, deleteImg: "deleteImg"}, function(data){
                	$("#image_preview").attr("href", "");
                	$("#image_preview").attr("data-lightbox", "");
                	$("#image_preview").attr("data-title", "");
                	$("#image_preview").html("text", "");
        });
}

function chcipniFile(){
	$("#fileManager #xtable>tbody>tr>td:nth-child(3n+1)").off();
	$("#fileManager #xtable>tbody>tr>td:nth-child(2)").off();
	$("#fileManager #xtable>tbody>tr>td:nth-child(3)").off();
}

function chcipniAllFile(){
	chcipniFile();
	$("#fileManager #xtable>thead>tr>td").off();
}

function closeDialog_file(){
	chcipniAllFile();
	$("#dlgFile").remove();
}
