//funkce ktera zobrazuje a skriva spravce verzi v menu
function initSpravceVerzi(){	
	if(dejPreferenci("vytvor_verze") == '1'){
		isVersion = true;	
		var url = document.location.toString();
		if(url.indexOf('?soubor') != -1){
			$('#spravce_verzi').show(); 
		}else{
			$('#spravce_verzi').hide();
		}

		// triger pro vraceni zmen v SVN = prejdu na revizi pred otevrenim dialogu
		$('#dlgVersion').on('dialogclose',function(event) {
			var pomURL = window.location.toString();
			// ziskani cesty pro prikaz updatei
			var pozice = pomURL.indexOf("=") + 1;
			var path = pomURL.substr(pozice);
			pozice = path.lastIndexOf("/");
			var dir_nm = path.substring(0,pozice+1);
			var file_nm = path.substr(pozice + 1);	  
			$.post("sprava_verzi.pl", {filename : file_nm, adresar : dir_nm, akce : 'upd', revize: revizeProRevert});               
		});
	}else{
		isVersion = false;
		$('#spravce_verzi').hide();
	}		
}

//funkce pro obarvovani radku v tabulce pri prejeti mysi
function obarviRadek(id, barva){
	var clsTr =  $('#'+id).attr('class');
	var color = $('#'+id).css('background-color').replace(/\s+/g, '');	
	if(clsTr != 'selected' && color !== 'rgb(182,246,62)'){
		$('#'+id).css('background-color',barva);	
	}
} 

//funkce pro odbarvovani radku v tabulce pri prejeti mysi
function odbarviRadek(id){
	var clsTr =  $('#'+id).attr('class');
	var color = $('#'+id).css('background-color').replace(/\s+/g, '');		
	if(clsTr != 'selected' && color !== 'rgb(182,246,62)'){
		$('#'+id).css('background-color','#FFFFFF');
	}
}

//funkce pro oznaceni radku v tabulce a nastaveni priznaku do atributu class
function oznacRadek(id){
	var idSlc = $('#slcTr').val();
	var idCurVer = 'verze_'+revizeProRevert;
	if(idSlc != ''){
		$('#'+idSlc).attr('class','');
		$('#'+idSlc).css('background-color','#FFFFFF');
		$('#slcTr').val('');
		$('#slcTr').val(id);
		$('#'+id).attr('class','selected');
		$('#'+id).css('background-color','#AEC1D0');
	}else{
		$('#slcTr').val(id);
		$('#'+id).attr('class','selected');
		$('#'+id).css('background-color','#AEC1D0');	
	}
	if(id != idCurVer)
		$('#'+idCurVer).css('background-color', '#B6F63E');
}

//funkce pro ziskani verzi otevreneho souboru
function dejVerze(path,directory){
	//zjisteni a ulozeni revize pred updatem, provadime kvuli zapomatovani v pripade ze uzivatel uzavre dialog a nevybere verzi, abychom mohli vratit zmeny
	$("#xtableVersion>tbody").html("<tr><td colspan=\"3\"><img src=\"file/loading.gif\" /></td></tr>");
	$.post("sprava_verzi.pl",{filename : path, adresar : directory, akce : 'info'}, function(data){
		revizeProRevert = data;
		$.post("sprava_verzi.pl",{filename : path, adresar : directory, akce : 'upd log'}, function(data){
			$('#xtableVersion>tbody').html(data);
			obarviRadek('verze_'+revizeProRevert, 'B6F63E');
		});	
	});
}

//funkce pro vlozeni souboru do SVN
function vlozSouborSVN(path,directory){ 
	$.post("sprava_verzi.pl", {filename : path, adresar : directory, akce : 'add cmt upd'});
}

function updateSVN(path, directory){
	$.post("sprava_verzi.pl", {filename : path, adresar : directory, akce : 'upd'}, function(){
		closeDialog_save(1, gup("soubor"));
	});
}

function commitSVN(path,directory){
	$.post("sprava_verzi.pl", {filename : path, adresar : directory, akce : 'cmt upd'});
}

//funkce pro prejmenovani souboru/adresaru v SVN
function prejmenujSouborSVN(path,oldname,newname){
	$("#xtable>tbody").html("<tr><td colspan=\"3\"><img src=\"file/loading.gif\" /></td></tr>");
	$.post("sprava_verzi.pl", {filename : path, oldnm : oldname, newnm : newname, akce : 'mov cmt upd'}, function(){
		//readFiles(path);
		renameFileToColaborators(path, oldname, newname)
	});		
}

//funkce pro presouvani souboru/adresaru v SVN
function presunSouborSVN(filenm,pth,pth2){
	$("#xtable>tbody").html("<tr><td colspan=\"3\"><img src=\"file/loading.gif\" /></td></tr>");	
	$.post("sprava_verzi.pl", {filename : filenm, from : pth, to : pth2, akce : 'mov cmt upd' }, function(){
		//readFiles(pth2);
		renameFileToColaborators(pth2, filenm, filenm);
	});	
}

//funkce pro kopirovani souboru/adersaru v SVN
function zkopirujSouborSVN(filenm,pth,pth2){
	$("#xtable>tbody").html("<tr><td colspan=\"3\"><img src=\"file/loading.gif\" /></td></tr>");	
	$.post("sprava_verzi.pl", {filename : filenm, from : pth, to : pth2, akce : 'cop cmt upd' }, function(){
		readFiles(pth2);
	});
}

//funkce pro odstraneni souboru z SVN
function odstranSouborSVN(path,directory){
	$("#xtable>tbody").html("<tr><td colspan=\"3\"><img src=\"file/loading.gif\" /></td></tr>");	
	$.post("sprava_verzi.pl", {filename : path, adresar : directory, akce : 'dlt cmt upd'}, function(){
		//readFiles(directory);	
		deleteFileToColaborators(directory, path);
	});
}

//doladit funkci pro vraceni k predchozím verzím. Když se provede update bez revize tak se vrati vsechny revize do sp. ver. např. přes tlačítko uložit
//funkce pro update otevreneho souboru na urcitou verzi
function updateToRevision(){
	//ziskani id radku tabulky
	var rev_val = $('#slcTr').val();	
	if(rev_val != ''){
		// ziskani cisla revize do SVN pro určitou verzi ze spravce verzi
		var rev =  $("#"+rev_val+" td:eq(0)").attr('abbr');
		var pomURL = window.location.toString();
		// ziskani cesty pro prikaz update
		var pozice = pomURL.indexOf("=") + 1;
		var path = pomURL.substr(pozice);
		pozice = path.lastIndexOf("/");
		var dir_nm = path.substring(0,pozice+1);
		var file_nm = path.substr(pozice + 1);
		// ziskani cesty pro prikaz commit
		$.post("sprava_verzi.pl", {filename : file_nm, adresar : dir_nm, akce : 'upd', revize: rev},function(){
			location.reload(true);
		});
	}else{
		alert(TranslVar[493]);
	}
}
