(function($) {
	$.fn.flashMessage = function(options) {
		options = $.extend({
			text: 'Done',
			time: 1500,
			method: 'append',
			className: 'info'
		}, options);
		
		return this.each(function() {
			if ($(this).find('.flash-message').get(0))
				return;
			
			var message = $('<div />', {
				'class': 'flash-message flash-message-' + options.className,
				text: options.text
			}).hide().fadeIn('fast');
			
			$(this)[options.method](message);
			
			message.delay(options.time).fadeOut('normal', function() {
				$(this).remove();
			});
			
		});
	};
}(jQuery));